/****************************************************************/
/* wiczenie 7 - Regulacja obrotw silnika DC                   */
/*               Modulacja PWM przy uyciu timera1              */
/* J.D. '2003                                                   */
/****************************************************************/
#include <io.h>

void czekaj(unsigned long zt) //procedura wytracania czasu
{
 #define tau 10.38
 unsigned char zt1;
 for(;zt>0;zt--)
 {
  for(zt1=255;zt1!=0;zt1--);
 }
}

int main( void )
{
 unsigned char licznikkl=0;  //zmienna wykorzystywana do pomiaru czasu
                             //nacinicia przyciskw
 char przyrost=1;  //przyrost zmiany wspczynnika wypenienia sygnau PWM
 union
      {
       unsigned int pwm;
       unsigned char pwmc[2];
      }volatile upwm;        //aktualny wspczynnik wypenienia sygn. PWM

 DDRB=0x08;    //PB3 - wy (OC1 - wyjcie PWM), pozostae we
 PORTB=0;      //bez podcigania
 DDRD=0xfc;    //PD1 i PD0 - we (obsuga klawiszy SW1 i SW4), pozostae wy
 PORTD=0x03;   //wejcia z podciganiem (potrzebne dla klawiatury)
 TCCR1A=0x83;  //PWM 10 bitowy
               //zerowanie OC1 po spenieniu warunku rwnoci podczas liczenia
               //w gr, 
               //ustawiane podczas liczenia w d
 TCCR1B=0x03;  //preskaler=3, co przy 10-bit PWM daje Fwy=ok. 61Hz @8MHz
 TCNT1L=0x00;  //wstpne ustawienie licznika1
 TCNT1H=0x00;
 upwm.pwm=0x3ff;   //pocztkowo silnik wczony, warto TOP odpowiada wysokiemu
                   //poziomowi na wyjciu OC1 (PB3)
 while(1)          //gwna ptla programu
 {
  if(bit_is_clear(PIND,1))   //czy wcinito SW4
  {
   upwm.pwm+=przyrost;       //zwiksz pwm
   if(upwm.pwm>0x3ff)
   {
    upwm.pwm=0x3ff;          //jeli przekroczono warto TOP, to ustaw TOP
   }
   czekaj(150*tau);          //eliminacja drga i powtrnej interpretacji 
                             //nacinicia przycisku 
   licznikkl++;              //mierz dugo nacinicia przycisku
  }
  else
  {
   if(bit_is_clear(PIND,0))  //czy wcinito SW1
   {
    upwm.pwm-=przyrost;      //zmniejsz pwm
    if(upwm.pwm>0x3ff)
    {
     upwm.pwm=0;             //jeli przekroczono warto zero to ustaw zero
    }
    czekaj(150*tau);         //eliminacja drga i powtrnej interpretacji 
                             //nacinicia przycisku
    licznikkl++;             //mierz dugo nacinicia przycisku
   }
   else
   {
    licznikkl=0;             //zeruj licznik pomiaru czasu nacinicia klawisza
                             //poniewa wszystkie przyciski s zwolnione
    przyrost=1;              //ustaw pocztkow warto przyrostu dla pwm
   }
  }
  if(licznikkl>6) 
  {
   przyrost=+16;             //wykryto dugie nacinicie przyciskw, 
                             //zwiksz krok regulacji
   licznikkl=6;             
  }
  OCR1H=upwm.pwmc[1];        //wpisz aktualnie ustawiony wspczynnik do rejestrw
  OCR1L=upwm.pwmc[0];        //OCR1 timera1
 }
}
